diff -urpN john-1.7.8-jumbo-6a/src/pkzip_fmt_plug.c john-1.7.8-jumbo-6b/src/pkzip_fmt_plug.c
--- john-1.7.8-jumbo-6a/src/pkzip_fmt_plug.c	2011-09-01 15:26:20.968750000 +0000
+++ john-1.7.8-jumbo-6b/src/pkzip_fmt_plug.c	2011-09-09 20:44:27.000000000 +0000
@@ -433,67 +491,106 @@ static void *get_salt(char *ciphertext)
 
 	cp = cpalloc;
 	strcpy((c8*)cp, ciphertext);
-	p = &cp[8];
+	p = &cp[7];
 	p = GetFld(p, &cp);
 	sscanf((c8*)cp, "%x", &(salt->cnt));
 	p = GetFld(p, &cp);
 	sscanf((c8*)cp, "%x", &(salt->chk_bytes));
-	p = GetFld(p, &cp);
-	sscanf((c8*)cp, "%x", &(salt->flags));
 	for(i = 0; i < salt->cnt; ++i) {
+		int data_enum;
 		p = GetFld(p, &cp);
-		salt->c[i] = atoi16[ARCH_INDEX(cp[24])];
-		salt->c[i] <<= 4;
-		salt->c[i] |= atoi16[ARCH_INDEX(cp[25])];
-		salt->c[i] <<= 4;
-		salt->c[i] |= atoi16[ARCH_INDEX(cp[26])];
-		salt->c[i] <<= 4;
-		salt->c[i] |= atoi16[ARCH_INDEX(cp[27])];
-		for (j = 0; j < 12; ++j)
-			salt->h[i][j] = (atoi16[ARCH_INDEX(cp[j*2])]<<4) + atoi16[ARCH_INDEX(cp[j*2+1])];
-	}
+		data_enum = *cp - '0';
+		p = GetFld(p, &cp);
+#if USE_PKZIP_MAGIC
+		sscanf((c8*)cp, "%hhx", &(salt->H[i].magic));
+		salt->H[i].pSig = &SIGS[salt->H[i].magic];
+#endif
 
-	/* Handle flags&2 */
-	p = GetFld(p, &cp);
-	if (salt->flags&2)
-		sscanf((c8*)cp, "%x", &(salt->asciilen));
-	p = GetFld(p, &cp);
-	if (salt->flags&2)
-		sscanf((c8*)cp, "%x", &(salt->asciiCompType));
-	p = GetFld(p, &cp);
-	if (salt->flags&2)
-		load_bin_data(cp, &(salt->asciidat));
+		if (data_enum > 1) {
+			p = GetFld(p, &cp);
+			sscanf((c8*)cp, "%x", &(salt->compLen));
+			p = GetFld(p, &cp);
+			sscanf((c8*)cp, "%x", &(salt->deCompLen));
+			p = GetFld(p, &cp);
+			sscanf((c8*)cp, "%x", &(salt->crc32));
+			p = GetFld(p, &cp);
+			sscanf((c8*)cp, "%lx", &offset);
+			p = GetFld(p, &cp);
+			sscanf((c8*)cp, "%x", &offex);
+		}
+		p = GetFld(p, &cp);
+		sscanf((c8*)cp, "%x", &(salt->H[i].compType));
+		p = GetFld(p, &cp);
+		sscanf((c8*)cp, "%x", &(salt->H[i].datlen));
+		p = GetFld(p, &cp);
 
-	/* Handle flags&4 */
-	p = GetFld(p, &cp);
-	if (salt->flags&4)
-		sscanf((c8*)cp, "%x", &(salt->crc32));
-	p = GetFld(p, &cp);
-	if (salt->flags&4)
-		sscanf((c8*)cp, "%x", &(salt->compLen));
-	p = GetFld(p, &cp);
-	if (salt->flags&4)
-		sscanf((c8*)cp, "%x", &(salt->deCompLen));
-	p = GetFld(p, &cp);
-	if (salt->flags&4)
-		sscanf((c8*)cp, "%x", &(salt->compType));
+		for (j = 0; j < 4; ++j) {
+			salt->H[i].c <<= 4;
+			salt->H[i].c |= atoi16[ARCH_INDEX(cp[j])];
+		}
+		p = GetFld(p, &cp);
+		if (data_enum > 1) {
+			/* if 2 or 3, we have the FULL zip blob for decrypting. */
+			if (data_enum == 3) {
+				/* read from file. */
+				FILE *fp;
+				fp = fopen((c8*)cp, "rb");
+				if (!fp) {
+					fprintf (stderr, "Error opening file for pkzip data:  %s\n", cp);
+					MEM_FREE(cpalloc);
+					return 0;
+				}
+				fseek(fp, offset+offex, SEEK_SET);
+				if (salt->compLen < 16*1024) {
+					/* simply load the whole blob */
+					salt->H[i].h = mem_alloc_tiny(salt->compLen, MEM_ALIGN_WORD);
+					if (fread(salt->H[i].h, 1, salt->compLen, fp) != salt->compLen) {
+						fprintf (stderr, "Error reading zip file for pkzip data:  %s\n", cp);
+						fclose(fp);
+						MEM_FREE(cpalloc);
+						return 0;
+					}
+					fclose(fp);
+					salt->H[i].datlen = salt->compLen;
+				}
+				else {
+					/* Only load a small part (to be used in crypt_all), and set the filename in */
+					/* the salt->fname string, so that cmp_all can open the file, and buffered   */
+					/* read the zip data only when it 'needs' it.                                */
+					salt->fname = str_alloc_copy((c8*)cp);
+					salt->offset = offset+offex;
+					salt->H[i].h = mem_alloc_tiny(384, MEM_ALIGN_WORD);
+					if (fread(salt->H[i].h, 1, 384, fp) != 384) {
+						fprintf (stderr, "Error reading zip file for pkzip data:  %s\n", cp);
+						fclose(fp);
+						MEM_FREE(cpalloc);
+						return 0;
+					}
+					fclose(fp);
+					salt->H[i].datlen = 384;
+				}
+			} else {
+				/* 'inline' data. */
+				if (salt->compLen != salt->H[i].datlen) {
+					fprintf(stderr, "Error, length of full data does not match the salt len. %s\n", ciphertext);
+					return 0;
+				}
+				salt->H[i].h = mem_alloc_tiny(salt->compLen, MEM_ALIGN_WORD);
+				for (j = 0; j < salt->H[i].datlen; ++j)
+					salt->H[i].h[j] = (atoi16[ARCH_INDEX(cp[j*2])]<<4) + atoi16[ARCH_INDEX(cp[j*2+1])];
+			}
 
-	/* Handle flags&8 */
-	p = GetFld(p, &cp);
-	if (salt->flags&8)
-		sscanf((c8*)cp, "%lx", &(salt->offset));
-	p = GetFld(p, &cp);
-	if (salt->flags&8)
-		salt->filename = str_alloc_copy((c8*)cp);
-	p = GetFld(p, &cp);
-	if (salt->flags&8)
-		salt->ifilename = str_alloc_copy((c8*)cp);
+			/* we also load this into the 'building' salt */
+			salt->compType = salt->H[i].compType;
 
-	/* Handle flags&16 */
-	p = GetFld(p, &cp);
-	if (salt->flags&16) {
-		load_bin_data(cp, &(salt->full_encr_dat));
-		salt->full_decr_dat = mem_alloc_tiny(salt->compLen-12, MEM_ALIGN_NONE);
+			/* Now, set the 'is full zip' flag, so we later process as a zip file. */
+			salt->H[i].full_zip = 1;
+			salt->full_zip_idx = i;
+		} else {
+			salt->H[i].h = mem_alloc_tiny(salt->H[i].datlen, MEM_ALIGN_WORD);
+			for (j = 0; j < salt->H[i].datlen; ++j)
+				salt->H[i].h[j] = (atoi16[ARCH_INDEX(cp[j*2])]<<4) + atoi16[ARCH_INDEX(cp[j*2+1])];
+		}
 	}
 
 	MEM_FREE(cpalloc);
@@ -511,133 +608,11 @@ static void set_key(char *key, int index
 	dirty = 1;
 }
 
-
 static char *get_key(int index)
 {
 	return saved_key[index];
 }
 
-/*
- * Crypt_all simply performs the checksum .zip validatation of the data. It performs
- * this for ALL hashes provided. If any of them fail to match, then crypt all puts the
- * complement of the 'proper' checksum of the first hash into the output. These 2 bytes
- * are checked against the binary for this salt/password combination.  Thus, if any
- * checksum fails, it will never match binary.  However, if ALL of the checksums match
- * we then put the checksum bytes from the first hash, into our output data. Then, when
- * the binary check (cmp_all, cmp_one) is performed, it WILL match.  NOTE, this does
- * not mean we have found the password.  Just that all hashes quick check checksums
- * for this password 'work'.
- */
-static void crypt_all(int _count)
-{
-	int idx;
-
-	// pkzip kinda sucks a little for multi-threading, since there is different amount of work to be
-	// done, depenging upon the password.  Thus, we pack in OMP_MOD passwords into each thread, and
-	// hopefully some of the differnces will even themselves out in the end.  If we have 2 threads
-	// then thread 1 gets 0 to 127 password, and thread 2 gets 128-256.  Once they 'get' their data,
-	// there should be no mutexing of the runtime data, thus the threads should run fast.
-	// Also, since we have 'multiple' files in a .zip file (and multiple checksums), we bail as at the
-	// first time we fail to match checksum.  So, there may be some threads which check more checksums.
-	// Again, hopefully globbing many tests into a threads working set will flatten out these differences.
-#ifdef _OPENMP
-#pragma omp parallel for private(idx)
-#endif
-	for (idx = 0; idx < _count; ++idx) {
-		int cur_hash_count = salt->cnt;
-		int cur_hash_idx = -1;
-		MY_WORD key0, key1, key2;
-		/* use the pwkey for each hash.  We mangle on the 12 bytes of IV to what  was computed in the pwkey load. */
-
-		if (dirty) {
-			u8 *p = (u8*)saved_key[idx];
-
-			/* load the 'pwkey' one time, put it into the K12 array */
-			key0.u = 0x12345678UL; key1.u = 0x23456789UL; key2.u = 0x34567890UL;
-			do {
-				key0.u = pkzip_crc32 (key0.u, *p++);
-#if ARCH_LITTLE_ENDIAN
-				key1.u = (key1.u + key0.c[0]) * 134775813 + 1;
-				key2.u = pkzip_crc32 (key2.u, key1.c[3]);
-#else
-				key1.u = (key1.u + key0.c[3]) * 134775813 + 1;
-				key2.u = pkzip_crc32 (key2.u, key1.c[0]);
-#endif
-			} while (*p);
-			K12[idx*3] = key0.u, K12[idx*3+1] = key1.u, K12[idx*3+2] = key2.u;
-			goto SkipKeyLoadInit;
-		}
-
-		do
-		{
-			u8 checkSum1, checkSum2;
-			const u8 *b;
-			int k;
-			u16 e;
-
-			// 2nd, and later times through the loop, AND if keys are not dirty (i.e. multiple salts
-			// for the same key load), we do NOT perform the key compute, but instead load the pre-computed
-			// key data from the array.
-			key0.u = K12[idx*3], key1.u = K12[idx*3+1], key2.u = K12[idx*3+2];
-
-SkipKeyLoadInit:;
-			b = salt->h[++cur_hash_idx];
-			k=11;
-			e = salt->c[cur_hash_idx];
-
-			do
-			{
-#ifdef PKZIP_USE_MULT_TABLE
-				checkSum2 = *b++ ^ mult_tab [(u16)(key2.u) >> 2];	/* 6850K/GCC  7230K/VC  Midrange Core 32 bit, Win32 */
-#else
-				u16 t = key2.u | 2;
-				checkSum2 = *b++ ^ (u8)(((u16) (t * (t^1)) >> 8));	/* 5926K/GCC  6429K/VC  Midrange Core 32 bit, Win32 */
-#endif
-				key0.u = pkzip_crc32 (key0.u, checkSum2);
-#if ARCH_LITTLE_ENDIAN
-				key1.u = (key1.u + key0.c[0]) * 134775813 + 1;
-				key2.u = pkzip_crc32 (key2.u, key1.c[3]);
-#else
-				key1.u = (key1.u + key0.c[3]) * 134775813 + 1;
-				key2.u = pkzip_crc32 (key2.u, key1.c[0]);
-#endif
-			}
-			while(--k);
-
-			/* if the hash is a 2 byte checksum type, then check that value first */
-			/* There is no reason to continue if this byte does not check out.  */
-			if (salt->chk_bytes == 2 && checkSum2 != (e&0xFF))
-				goto Failed_Bailout;
-
-#ifdef PKZIP_USE_MULT_TABLE
-			checkSum1 = *b++ ^ mult_tab [(u16)(key2.u) >> 2];
-#else
-			{
-				u16 t = key2.u | 2;
-				checkSum1 = *b++ ^ (u8)(((u16) (t * (t^1)) >> 8));
-			}
-#endif
-			if (checkSum1 != (e>>8))
-				goto Failed_Bailout;
-		}
-		while(--cur_hash_count);
-
-		/* We got a checksum HIT!!!! All hash checksums matched. */
-		/* We load the proper checksum value for the gethash */
-		chk[idx] = 1;
-
-		continue;
-		
-Failed_Bailout: ;
-		/* We load the wrong checksum value for the gethash */
-		chk[idx] = 0;
-	}
-
-	/* clear the 'dirty' flag.  Then on multiple different salt calls, we will not have to */
-	/* encrypt the passwords again. They will have already been loaded in the K12[] array. */
-	dirty = 0;
-}
-
 static int cmp_one(void *binary, int idx)
 {
 	return chk[idx] == 1;
@@ -645,138 +620,243 @@ static int cmp_one(void *binary, int idx
 
 static int cmp_all(void *binary, int count)
 {
-	return memchr(chk, 1, count) != NULL;
+	int i,j;
+	for (i=j=0; i<count; ++i)
+		j+=chk[i]; /* hopefully addition like this is faster then 'count' conditional if statments */
+	return j;
 }
 
-static void decrypt (int idx, u8 *inp, u8 *out, int inplen) {
-	MY_WORD key0, key1, key2;
+/* this function is used by cmp_exact_loadfile.  It will load the next 
+ * part of the file then decrypt the data, and return just how many
+ * bytes were loaded.
+ *
+ * This function is 'similar' to an fread().  However, it also decrypts data 
+ */
+static int get_next_decrypted_block(u8 *in, int sizeof_n, FILE *fp, u32 *inp_used, MY_WORD *pkey0, MY_WORD *pkey1, MY_WORD *pkey2) {
+	u32 new_bytes = sizeof_n, k;
 	u8 C;
-	int k=12;
-	const u8 *b = inp;
-
-	/* load pre-computed key data */
-	key0.u = K12[idx*3], key1.u = K12[idx*3+1], key2.u = K12[idx*3+2];
 
-	/* Load the IV into the keys. */
-	do {
-#ifdef PKZIP_USE_MULT_TABLE
-		C = *b++ ^ mult_tab [(u16)(key2.u) >> 2];
-#else
-		u16 t = key2.u | 2;
-		C = *b++ ^ (u8)(((u16) (t * (t^1)) >> 8));
-#endif
-		key0.u = pkzip_crc32 (key0.u, C);
-#if ARCH_LITTLE_ENDIAN
-		key1.u = (key1.u + key0.c[0]) * 134775813 + 1;
-		key2.u = pkzip_crc32 (key2.u, key1.c[3]);
-#else
-		key1.u = (key1.u + key0.c[3]) * 134775813 + 1;
-		key2.u = pkzip_crc32 (key2.u, key1.c[0]);
-#endif
-	} while (--k);
+	/* we have read all the bytes, we're done */
+	if (*inp_used >= salt->compLen)
+		return 0;
+	if (*inp_used + new_bytes > salt->compLen)
+		/* this is the last block.  Only load the bytes that are left */
+		new_bytes = salt->compLen - *inp_used;
+	/* return the correct 'offset', so we can track when the file buffer has been fully read */
+	*inp_used += new_bytes;
+	/* read the data */
+	if (fread(in, 1, new_bytes, fp) != new_bytes)
+		return 0;
 
-	/* now decrypt the rest of the data. */
-	k = inplen-12;
-	do {
-#ifdef PKZIP_USE_MULT_TABLE
-		C = *b++ ^ mult_tab [(u16)(key2.u) >> 2];
-#else
-		u16 t = key2.u | 2;
-		C = *b++ ^ (u8)(((u16) (t * (t^1)) >> 8));
-#endif
-		/* write out this decrypted byte. */
-		*out++ = C;
-		key0.u = pkzip_crc32 (key0.u, C);
-#if ARCH_LITTLE_ENDIAN
-		key1.u = (key1.u + key0.c[0]) * 134775813 + 1;
-		key2.u = pkzip_crc32 (key2.u, key1.c[3]);
-#else
-		key1.u = (key1.u + key0.c[3]) * 134775813 + 1;
-		key2.u = pkzip_crc32 (key2.u, key1.c[0]);
-#endif
-	} while (--k);
+	/* decrypt the data bytes (in place, in same buffer). Easy to do, only requires 1 temp character variable.  */
+	for (k = 0; k < new_bytes; ++k) {
+		C = PKZ_MULT(in[k],(*pkey2));
+		pkey0->u = pkzip_crc32 (pkey0->u, C);
+		pkey1->u = (pkey1->u + pkey0->c[KB1]) * 134775813 + 1;
+		pkey2->u = pkzip_crc32 (pkey2->u, pkey1->c[KB2]);
+		in[k] = C;
+	}
+	/* return the number of bytes we read from the file on this read */
+	return new_bytes;
 }
 
-/*
- * This is the 'third' step in cracking the key. We do a full decrypt, then
- * full inflate, and then make sure the size and CRC matches.
+/* Ok, this is the more complex example.  Here we have to load the file (which may be HUGE)
+ * decrypt the bytes from this file, and then inflate that data, and crc the bytes which we
+ * have inflated from that stream. Then in the end, when we use all input bytes, if we have
+ * inflated the right amount of data, ended up with a Z_STREAM_END, and the proper sized
+ * decompression buffer, and the CRC matches, then we know we have the correct password 
+ *
+ * This function is called from cmp_exact(), when cmp_exact finds out we have to decrypt from
+ * the stored .zip file.
+ *
+ * this code is modifications made to the zpipe.c 'example' code from the zlib web site.
  */
-static int decomp_validate(u8 *inp, int inplen, int outlen, u32 crcExpect) {
-	z_stream strm;
-	int ret, i;
-	u32 crc = 0xFFFFFFFF; /* Later we will have to check ~crc to see if the crc matches */
-	int last_out, bytes_this_time;
-
-	if (salt->compType == 0) {
-		/* file is stored, so simply CRC the data) */
-		if (inplen != outlen)
-			return 0;
-		for (i = 0; i < inplen; ++i)
-			crc = pkzip_crc32(crc,inp[i]);
-		return ~crc == crcExpect;
-	}
-
-	strm.zalloc = Z_NULL;
-	strm.zfree = Z_NULL;
-	strm.opaque = Z_NULL;
-	strm.avail_in = 0;
-	strm.next_in = Z_NULL;
-
-	ret = inflateInit2(&strm, -15); /* 'raw', since we do not have gzip header, or gzip crc. .ZIP files are 'raw' implode data. */
-	if (ret != Z_OK)
-	   perror("Error, initializing the libz inflateInit2() system\n");
+#define CHUNK (64*1024)
+static int cmp_exact_loadfile(int index) {
 
-	strm.avail_in = inplen;
-	strm.next_in = inp;
+    int ret;
+    u32 have, k;
+    z_stream strm;
+    unsigned char in[CHUNK];
+    unsigned char out[CHUNK];
+	FILE *fp;
+	MY_WORD key0, key1, key2;
+	u8 *b, C;
+	u32 inp_used, decomp_len=0;
+	u32 crc = 0xFFFFFFFF;
+
+	/* Open the zip file, and 'seek' to the proper offset of the binary zip blob */
+	fp = fopen(salt->fname, "rb");
+	if (!fp) {
+		fprintf (stderr, "\nERROR, the zip file: %s has been removed.\nWe are a possible password has been found, but FULL validation can not be done!\n", salt->fname);
+		return 1;
+	}
+	if (fseek(fp, salt->offset, SEEK_SET)) {
+		fprintf (stderr, "\nERROR, the zip file: %s fseek() failed.\nWe are a possible password has been found, but FULL validation can not be done!\n", salt->fname);
+		fclose(fp);
+		return 1;
+	}
+
+    /* allocate inflate state */
+    strm.zalloc = Z_NULL;
+    strm.zfree = Z_NULL;
+    strm.opaque = Z_NULL;
+    strm.avail_in = 0;
+    strm.next_in = Z_NULL;
+    ret = inflateInit2(&strm, -15);
+	if (ret != Z_OK) /* if zlib is hosed, then likely there is no reason at all to continue.  Better to exit, and let the user 'fix' the system */
+		perror("Error, initializing the libz inflateInit2() system\n");
+
+	/* 'seed' the decryption with the IV. We do NOT use these bytes, they simply seed us. */
+	key0.u = K12[index*3], key1.u = K12[index*3+1], key2.u = K12[index*3+2];
+	k=12;
+	if (fread(in, 1, 12, fp) != 12) {
+		fprintf (stderr, "\nERROR, the zip file: %s fread() failed.\nWe are a possible password has been found, but FULL validation can not be done!\n", salt->fname);
+		fclose(fp);
+		return 1;
+	}
 
+	b = salt->H[salt->full_zip_idx].h;
 	do {
-		strm.avail_out = UBUF_SIZE;
-		strm.next_out = ucpr_buf;
-		last_out = strm.total_out;
+		C = PKZ_MULT(*b++,key2);
+		key0.u = pkzip_crc32 (key0.u, C);
+		key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+		key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+	}
+	while(--k);
 
-		ret = inflate(&strm, Z_SYNC_FLUSH);
-		if (ret != Z_OK) {
-			inflateEnd(&strm);
-			if (ret == Z_STREAM_END) {
-				/* This is the MOST LIKELY successful spot. */
-				if (strm.total_out != outlen)
+	/* this is 'sort of' our file pointer.  It is the 'index' into the file's encrypted, compressed data buffer. */
+	/* we have read the 12 bytes of IV data, and updated our keys. Now we start processing the rest of the bytes */
+	/* to get the data to inflate, and crc check                                                                 */
+	inp_used = 12;
+
+    /* decompress until deflate stream ends or end of file */
+    do {
+        strm.avail_in = get_next_decrypted_block(in, CHUNK, fp, &inp_used, &key0, &key1, &key2);
+        if (ferror(fp)) {
+            inflateEnd(&strm);
+			fclose(fp);
+			fprintf (stderr, "\nERROR, the zip file: %s fread() failed.\nWe are a possible password has been found, but FULL validation can not be done!\n", salt->fname);
+            return 1;
+        }
+        if (strm.avail_in == 0)
+            break;
+        strm.next_in = in;
+
+        /* run inflate() on input until output buffer not full */
+        do {
+            strm.avail_out = CHUNK;
+            strm.next_out = out;
+            ret = inflate(&strm, Z_NO_FLUSH);
+            switch (ret) {
+	            case Z_NEED_DICT:
+			    case Z_DATA_ERROR:
+				case Z_MEM_ERROR:
+					inflateEnd(&strm);
+					fclose(fp);
 					return 0;
-				bytes_this_time = strm.total_out - last_out;
-				for (i = 0; i < bytes_this_time; ++i)
-					crc = pkzip_crc32(crc,ucpr_buf[i]);
-				if (~crc == crcExpect) {
-					/* yea!  we found it.                     */
-					/* This time we KNOW we have the password */
+            }
+            have = CHUNK - strm.avail_out;
+			/* now update our crc value */
+			for (k = 0; k < have; ++k)
+				crc = pkzip_crc32(crc,out[k]);
+			decomp_len += have;
+        } while (strm.avail_out == 0);
+
+        /* done when inflate() says it's done */
+    } while (ret != Z_STREAM_END);
+
+    /* clean up and return */
+    inflateEnd(&strm);
+	fclose(fp);
+	return ret == Z_STREAM_END && inp_used == salt->compLen && decomp_len == salt->deCompLen && salt->crc32 == ~crc;
+}
+
+
+static int cmp_exact(char *source, int index)
+{
+	const u8 *b;
+	u8 C, *decompBuf, *decrBuf, *B;
+	u32 k, crc;
+	MY_WORD key0, key1, key2;
+	z_stream strm;
+	int ret;
+	
+	if (salt->H[salt->full_zip_idx].full_zip == 0)
+		/* we do not have a zip file, this is 'checksum' only
+		 * POSSIBLY, we should log and output to screen that 
+		 * we are not 100% 'sure' we have the right password!! */
+		return 1;
+
 #ifdef ZIP_DEBUG
-					fprintf(stderr, "YEA, Found it!! (full zip validation)  Crc=%x Expected=%x\n", ~crc, crcExpect);
+	fprintf(stderr, "FULL zip test being done. (pass=%s)\n", saved_key[index]);
 #endif
-					return 1;
-				}
-			}
-			return 0;
+
+	if (salt->fname == NULL) {
+		/* we have the whole zip blob in memory, simply allocate a decrypt buffer, decrypt
+		 * in one step, crc and be done with it. This is the 'trivial' type. */
+		decompBuf = mem_alloc(salt->deCompLen);
+		decrBuf = mem_alloc(salt->compLen-12);
+
+		key0.u = K12[index*3], key1.u = K12[index*3+1], key2.u = K12[index*3+2];
+
+		b = salt->H[salt->full_zip_idx].h;
+		k=12;
+		do {
+			C = PKZ_MULT(*b++,key2);
+			key0.u = pkzip_crc32 (key0.u, C);
+			key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+			key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
 		}
-		bytes_this_time = strm.total_out - last_out;
-		for (i = 0; i < bytes_this_time; ++i)
-			crc = pkzip_crc32(crc,ucpr_buf[i]);
-		if (strm.total_out > outlen) {
-			inflateEnd(&strm);
+		while(--k);
+		B = decrBuf;
+		k = salt->compLen-12;
+		do {
+			C = PKZ_MULT(*b++,key2);
+			key0.u = pkzip_crc32 (key0.u, C);
+			*B++ = C;
+			key1.u = (key1.u + key0.c[KB1]) * 134775813 + 1;
+			key2.u = pkzip_crc32 (key2.u, key1.c[KB2]);
+		} while (--k);
+
+		strm.zalloc = Z_NULL; strm.zfree = Z_NULL; strm.opaque = Z_NULL; strm.next_in = Z_NULL; strm.avail_in = 0;
+
+		ret = inflateInit2(&strm, -15); /* 'raw', since we do not have gzip header, or gzip crc. .ZIP files are 'raw' implode data. */
+		if (ret != Z_OK)
+		   perror("Error, initializing the libz inflateInit2() system\n");
+
+		strm.next_in = decrBuf;
+		strm.avail_in = salt->compLen-12;
+		strm.avail_out = salt->deCompLen;
+		strm.next_out = decompBuf;
+
+
+		ret = inflate(&strm, Z_SYNC_FLUSH);
+		inflateEnd(&strm);
+		if (ret != Z_STREAM_END || strm.total_out != salt->deCompLen) {
+			MEM_FREE(decompBuf);
+			MEM_FREE(decrBuf);
 			return 0;
 		}
-	} while (bytes_this_time == UBUF_SIZE);
 
-	/* this will likely only happen, if the output len mod UBUF_SIZE == 0, but it 'can' happen. */
-	inflateEnd(&strm);
-	if (~crc != crcExpect || strm.total_out != outlen)
-		return 0;
-	/* yea!  we found it. */
-	return 1;
+		crc = 0xFFFFFFFF;
+		for (k = 0; k < strm.total_out; ++k)
+			crc = pkzip_crc32(crc,decompBuf[k]);
+		MEM_FREE(decompBuf);
+		MEM_FREE(decrBuf);
+		return ~crc == salt->crc32;
+	}
+	/* we have a stand alone function to handle this more complex method of
+	 * loading from file, decrypting, decompressing, and crc'ing the data
+	 * It is complex enough of a task, to have it's own function. */
+	return cmp_exact_loadfile(index);
 }
 
+#if USE_PKZIP_MAGIC
 const char exBytesUTF8[64] = {
 	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, 3,3,3,3,3,3,3,3,4,4,4,4,5,5,5,5
 };
-
 static int isLegalUTF8_char(const u8 *source, int length) {
     u8 a;
 	int len;
